package st.tori.jpredict.levistone.activity;

import java.util.ArrayList;
import java.util.List;

import st.tori.android.core.util.DialogUtil;
import st.tori.jpredict.levistone.bizlogic.ReadWriteThread;
import st.tori.jpredict.levistone.bizlogic.ReadWriteThread.ReadListener;
import st.tori.jpredict.levistone.exception.CalibrationRequiredException;
import st.tori.jpredict.levistone.orm.Operand;
import st.tori.jpredict.levistone.orm.OperandRotate;
import st.tori.jpredict.levistone.orm.OperandSequence;
import st.tori.jpredict.levistone.orm.OperandSwitch;
import st.tori.jpredict.levistone.orm.SwitchStatus;
import android.content.Intent;
import android.os.Bundle;
import android.os.Handler;
import android.util.Log;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.MotionEvent;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.View.OnTouchListener;
import android.widget.Button;
import android.widget.CompoundButton;
import android.widget.CompoundButton.OnCheckedChangeListener;
import android.widget.LinearLayout;
import android.widget.SeekBar;
import android.widget.SeekBar.OnSeekBarChangeListener;
import android.widget.TextView;
import android.widget.ToggleButton;

public class CalibrateActivity extends AbstractCalibrateActivity implements OnClickListener, OnCheckedChangeListener, OnTouchListener, OnSeekBarChangeListener {
	
	private static final String TAG = "CalibrateActivity";
	
	private Handler handler = new Handler();
	
    
    private void updateCo(){
    	if(y_a_0!=Integer.MAX_VALUE&&y_e_90!=Integer.MAX_VALUE&&y_a_360==Integer.MAX_VALUE&&y_e_0==Integer.MAX_VALUE){
    		coefficientText.setText("y_a_0="+y_a_0+",y_e_90="+y_e_90+".Please calibrate 360/0");
    	}else if(y_a_0==Integer.MAX_VALUE&&y_e_90==Integer.MAX_VALUE&&y_a_360!=Integer.MAX_VALUE&&y_e_0!=Integer.MAX_VALUE){
    		coefficientText.setText("y_a_360="+y_a_360+",y_e_0="+y_e_0+".Please calibrate 0/90");
    	}else if(y_a_0!=Integer.MAX_VALUE&&y_e_90!=Integer.MAX_VALUE&&y_a_360!=Integer.MAX_VALUE&&y_e_0!=Integer.MAX_VALUE){
    		try {
				super.updateCo(y_a_0,y_a_360,y_e_0,y_e_90,false);
			} catch (CalibrationRequiredException e) {
				e.printStackTrace();
			}
			rawAz = (int)(a_az * 0.0 + b_az);
			rawEl = (int)(a_el * 90.0 + b_el);
			updateAzEl(false);
    		coefficientText.setText(y_a_0+"/"+y_a_360+"->"+a_az+"/"+b_az+"\n"+y_e_0+"/"+y_e_90+"->"+a_el+"/"+b_el);
			warmupButton.setEnabled(true);
    	}
    }
    
    private int rawAz = 90;
    private int rawEl = 90;
    private static final int largeStep = 10;
    private static final int smallStep = 1;
    
	private LinearLayout calibrateBackground;
    private TextView azText;
	private SeekBar azSeek;
	private Button azDecLargeButton;
	private Button azDecSmallButton;
	private Button azIncLargeButton;
	private Button azIncSmallButton;
	private TextView elText;
	private SeekBar elSeek;
	private Button elDecLargeButton;
	private Button elDecSmallButton;
	private Button elIncLargeButton;
	private Button elIncSmallButton;
	private TextView coefficientText;
	private Button calibrateButton_000_90;
	private Button calibrateButton_360_00;
	private Button warmupButton;
	
	private ToggleButton blueToggle;
	private ToggleButton laserToggle;
	private ToggleButton redToggle;
	private Button laserActivateButton;

	private void updateAzEl(boolean write){
		updateAz();
		updateEl();
		if(!write)return;
		operandRotate.moveTo(rawAz,rawEl,true);
		writeIfPossible();
	}
	private void updateAz(){
		if(rawAz<=0){
			rawAz = 0;
		}else if(rawAz>=180){
			rawAz = 180;
		}
		if(rawAz<=0){
			azDecLargeButton.setEnabled(false);
			azDecSmallButton.setEnabled(false);
			azIncLargeButton.setEnabled(true);
			azIncSmallButton.setEnabled(true);
		}else if(rawAz>=180){
			azDecLargeButton.setEnabled(true);
			azDecSmallButton.setEnabled(true);
			azIncLargeButton.setEnabled(false);
			azIncSmallButton.setEnabled(false);
		}else{
			if(!azDecLargeButton.isEnabled())azDecLargeButton.setEnabled(true);
			if(!azDecSmallButton.isEnabled())azDecSmallButton.setEnabled(true);
			if(!azIncLargeButton.isEnabled())azIncLargeButton.setEnabled(true);
			if(!azIncLargeButton.isEnabled())azIncSmallButton.setEnabled(true);
		}
		azSeek.setProgress(rawAz);
		azText.setText(Integer.toString(rawAz));
	}
	private void updateEl(){
		if(rawEl<=0){
			rawEl = 0;
		}else if(rawEl>=180){
			rawEl = 180;
		}
		if(rawEl<=0){
			elDecLargeButton.setEnabled(false);
			elDecSmallButton.setEnabled(false);
			elIncLargeButton.setEnabled(true);
			elIncSmallButton.setEnabled(true);
		}else if(rawEl>=180){
			elDecLargeButton.setEnabled(true);
			elDecSmallButton.setEnabled(true);
			elIncLargeButton.setEnabled(false);
			elIncSmallButton.setEnabled(false);
		}else{
			if(!elDecLargeButton.isEnabled())elDecLargeButton.setEnabled(true);
			if(!elDecSmallButton.isEnabled())elDecSmallButton.setEnabled(true);
			if(!elIncLargeButton.isEnabled())elIncLargeButton.setEnabled(true);
			if(!elIncLargeButton.isEnabled())elIncSmallButton.setEnabled(true);
		}
		elSeek.setProgress(rawEl);
		elText.setText(Integer.toString(rawEl));
	}
	
    @Override
    protected String getBluetoothTargetDeviceName(){
    	return "ARDUINOBT";
    }
    @Override
	protected String getBluetoothTargetPassKey(){
		return "12345";
	}
    @Override
    protected void onBluetoothConnectResult(int result){
    	if(result==RESULT_OK){
    	    try {
    			updateCoWithDB(false);
    	    	switchStatus.setAuto(false);
    			writeNow(new OperandSwitch(switchStatus, SwitchStatus.LED_MODE_OFF, SwitchStatus.LASER_MODE_OFF, SwitchStatus.LED_MODE_OFF));
    		} catch (CalibrationRequiredException e) {
    			e.printStackTrace();
    		}
    	}else{
    		DialogUtil.showSimpleDialog(this, "Error", "Cannot connect to levistone.Please make sure that it's close and turned on.");
    	}
    }
    
    @Override
    public void onCreate(Bundle savedInstanceState) {
        Log.d(TAG,"onCreate1");
        super.onCreate(savedInstanceState);
        setContentView(R.layout.calibrate);

        calibrateBackground = (LinearLayout)findViewById(R.id.calibrateBackground);
        calibrateBackground.setBackgroundResource(R.drawable.laputa_normal);
        azSeek = (SeekBar)findViewById(R.id.azSeek);
		azText = (TextView)findViewById(R.id.azText);
		azDecLargeButton = (Button)findViewById(R.id.azDecLargeButton);
		azDecSmallButton = (Button)findViewById(R.id.azDecSmallButton);
		azIncLargeButton = (Button)findViewById(R.id.azIncLargeButton);
		azIncSmallButton = (Button)findViewById(R.id.azIncSmallButton);
		elSeek = (SeekBar)findViewById(R.id.elSeek);
		elText = (TextView)findViewById(R.id.elText);
		elDecLargeButton = (Button)findViewById(R.id.elDecLargeButton);
		elDecSmallButton = (Button)findViewById(R.id.elDecSmallButton);
		elIncLargeButton = (Button)findViewById(R.id.elIncLargeButton);
		elIncSmallButton = (Button)findViewById(R.id.elIncSmallButton);
		coefficientText = (TextView)findViewById(R.id.coefficientText);
		calibrateButton_000_90 = (Button)findViewById(R.id.calibrateButton_000_90);
		calibrateButton_360_00 = (Button)findViewById(R.id.calibrateButton_360_00);
		warmupButton = (Button)findViewById(R.id.warmupButton);
		warmupButton.setEnabled(false);
    	blueToggle = (ToggleButton)findViewById(R.id.blueToggle);
    	laserToggle = (ToggleButton)findViewById(R.id.laserToggle);
    	redToggle = (ToggleButton)findViewById(R.id.redToggle);
    	laserActivateButton = (Button)findViewById(R.id.laserActivateButton);

        onCreateBluetooth(savedInstanceState);

        azSeek.setMax(180);
		azSeek.setProgress(rawAz);
		azSeek.setOnSeekBarChangeListener(this);
		elSeek.setMax(180);
		elSeek.setProgress(rawEl);
		elSeek.setOnSeekBarChangeListener(this);

		azDecLargeButton.setOnClickListener(this);
		azDecSmallButton.setOnClickListener(this);
		azIncLargeButton.setOnClickListener(this);
		azIncSmallButton.setOnClickListener(this);
		elDecLargeButton.setOnClickListener(this);
		elDecSmallButton.setOnClickListener(this);
		elIncLargeButton.setOnClickListener(this);
		elIncSmallButton.setOnClickListener(this);
		calibrateButton_000_90.setOnClickListener(this);
		calibrateButton_360_00.setOnClickListener(this);
		warmupButton.setOnClickListener(this);
		
    	blueToggle.setOnCheckedChangeListener(this);
    	laserToggle.setOnCheckedChangeListener(this);
    	redToggle.setOnCheckedChangeListener(this);
    	laserActivateButton.setOnTouchListener(this);
    	
    }
    
    private Thread thread;
    
    private OperandSequence operandSequence = new OperandSequence();
    private Operand[] operands = new Operand[]{operandSequence,operandCalibrateAaz,operandCalibrateBaz,operandCalibrateAel,operandCalibrateBel,operandRotate};
    private Operand currentOperand = null;
    
    protected void writeIfPossible(){
    	if(currentOperand!=null){
    		Log.d(TAG,"writeIfPossible:exit by lock");
    		return;
    	}
    	for(int i=0;i<operands.length;i++){
    		if(!operands[i].isWaiting())continue;
        	currentOperand = operands[i];
        	openBluetoothSocketIfClosed();
    		thread = new ReadWriteThread(getBluetoothSocket(),offsets,currentOperand,new MyListener());
    		thread.start();
    		return;
    	}
    	closeBluetoothSocket(false);
    }
    
	private class MyListener implements ReadListener {
		@Override
		public void read(String cmdStr,String response) {
			if(currentOperand!=null){
				if(currentOperand instanceof OperandSequence){
					if(((OperandSequence)currentOperand).hasNext()){
			        	openBluetoothSocketIfClosed();
			    		thread = new ReadWriteThread(getBluetoothSocket(),offsets,currentOperand,new MyListener());
			    		thread.start();
						return;
					}else{
						currentOperand = null;
					}
				}else{
					currentOperand = null;
				}
			}
			handler.post(new Runnable() {
				@Override
				public void run() {
					writeIfPossible();
				}
			});
		}
	}

	@Override
    protected void onPause() {
    	super.onPause();
    	if(thread!=null)
    		thread.stop();
    }
    
	@Override
	public void onClick(View v) {
		if(v.getId()==azDecLargeButton.getId()){
			rawAz -= largeStep;
			updateAzEl(true);
		}else if(v.getId()==azDecSmallButton.getId()){
			rawAz -= smallStep;
			updateAzEl(true);
		}else if(v.getId()==azIncLargeButton.getId()){
			rawAz += largeStep;
			updateAzEl(true);
		}else if(v.getId()==azIncSmallButton.getId()){
			rawAz += smallStep;
			updateAzEl(true);
		}else if(v.getId()==elDecLargeButton.getId()){
			rawEl -= largeStep;
			updateAzEl(true);
		}else if(v.getId()==elDecSmallButton.getId()){
			rawEl -= smallStep;
			updateAzEl(true);
		}else if(v.getId()==elIncLargeButton.getId()){
			rawEl += largeStep;
			updateAzEl(true);
		}else if(v.getId()==elIncSmallButton.getId()){
			rawEl += smallStep;
			updateAzEl(true);
		}else if(v.getId()==calibrateButton_000_90.getId()){
			y_a_0 = rawAz;
			y_e_90 = rawEl;
			updateCo();
		}else if(v.getId()==calibrateButton_360_00.getId()){
			y_a_360 = rawAz;
			y_e_0 = rawEl;
			updateCo();
		}else if(v.getId()==warmupButton.getId()){
			warmupButton.setEnabled(false);
			List<Operand> operandList = new ArrayList<Operand>();
			long timeInMillis = System.currentTimeMillis() + 3*1000;
			int az = 0;
			int el = 90;
			boolean useRaw = false;
			for(int i=0;i<180;i+=6){
				az = i;
				el = 90-i/2;
				Operand operand = (useRaw)?new OperandRotate(rotateStatus, offsets, az, el, false):new OperandRotate(rotateStatus, offsets, a_az*az+b_az, a_el*el+b_el, true);
				operand.setWaitUntilInMillis(timeInMillis);
				operandList.add(operand);
				timeInMillis += 300;
			}
			for(int i=180;i<=360;i+=6){
				az = i;
				el = i/2-90;
				Operand operand = (useRaw)?new OperandRotate(rotateStatus, offsets, az, el, false):new OperandRotate(rotateStatus, offsets, a_az*az+b_az, a_el*el+b_el, true);
				operand.setWaitUntilInMillis(timeInMillis);
				operandList.add(operand);
				timeInMillis += 300;
			}
			timeInMillis += 1000;
			for(int i=360;i>180;i-=6){
				az = i;
				el = i/2-90;
				Operand operand = (useRaw)?new OperandRotate(rotateStatus, offsets, az, el, false):new OperandRotate(rotateStatus, offsets, a_az*az+b_az, a_el*el+b_el, true);
				operand.setWaitUntilInMillis(timeInMillis);
				operandList.add(operand);
				timeInMillis += 300;
			}
			for(int i=180;i>=0;i-=6){
				az = i;
				el = 90-i/2;
				Operand operand = (useRaw)?new OperandRotate(rotateStatus, offsets, az, el, false):new OperandRotate(rotateStatus, offsets, a_az*az+b_az, a_el*el+b_el, true);
				operand.setWaitUntilInMillis(timeInMillis);
				operandList.add(operand);
				timeInMillis += 300;
			}
			operandSequence.setOperands(operandList);
			writeIfPossible();
			warmupButton.setEnabled(true);
		}
	}
	
	@Override
	public void onProgressChanged(SeekBar seekBar, int progress, boolean fromTouch) {
		if(seekBar.getId()==azSeek.getId()){
			rawAz = progress;
			Log.d(TAG,"onProgressChanged:rawAz="+progress);
		}else if(seekBar.getId()==elSeek.getId()){
			rawEl = progress;
			Log.d(TAG,"onProgressChanged:rawEl="+progress);
		}
		updateAzEl(true);
	}
	@Override
	public void onStartTrackingTouch(SeekBar seekBar) {}
	@Override
	public void onStopTrackingTouch(SeekBar seekBar) {}

    protected SwitchStatus switchStatus = new SwitchStatus(true,SwitchStatus.LED_MODE_ON,SwitchStatus.LASER_MODE_ON,SwitchStatus.LED_MODE_ON);
	@Override
	public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
    	Log.d(TAG,"%%%onCheckedChanged START:isAuto()="+switchStatus.isAuto());
		if(buttonView.getId()==blueToggle.getId()&&!switchStatus.isAuto()){
			int blueMode = (isChecked)?SwitchStatus.LED_MODE_ON:SwitchStatus.LED_MODE_OFF;
	    	Log.d(TAG,"%%%onCheckedChanged blueToggled");
			writeNow(new OperandSwitch(switchStatus, blueMode, switchStatus.getLaserMode(), switchStatus.getRedMode()));
		}else if(buttonView.getId()==laserToggle.getId()&&!switchStatus.isAuto()){
	    	Log.d(TAG,"%%%onCheckedChanged laserToggled");
		}else if(buttonView.getId()==redToggle.getId()&&!switchStatus.isAuto()){
			int redMode = (isChecked)?SwitchStatus.LED_MODE_ON:SwitchStatus.LED_MODE_OFF;
	    	Log.d(TAG,"%%%onCheckedChanged redToggled");
			writeNow(new OperandSwitch(switchStatus, switchStatus.getBlueMode(), switchStatus.getLaserMode(), redMode));
		}
    	Log.d(TAG,"%%%onCheckedChanged END");
	}
    protected void writeNow(Operand operand){
    	if(operand==null)return;
    	openBluetoothSocketIfClosed();
		thread = new ReadWriteThread(getBluetoothSocket(),offsets,operand,null);
		thread.start();
    }
	@Override
	public boolean onTouch(View v, MotionEvent event) {
		if(v.getId()!=laserActivateButton.getId())return false;
		if(event.getAction()==MotionEvent.ACTION_DOWN&&laserToggle.isChecked()){
	    	Log.d(TAG,"%%%onTouch:LASER ON BY ACTION_DOWN");
			writeNow(new OperandSwitch(switchStatus, switchStatus.getBlueMode(), SwitchStatus.LASER_MODE_ON, switchStatus.getRedMode()));
		}else if(event.getAction()==MotionEvent.ACTION_UP){
	    	Log.d(TAG,"%%%onTouch:LASER OFF BY ACTION_UP");
			writeNow(new OperandSwitch(switchStatus, switchStatus.getBlueMode(), SwitchStatus.LASER_MODE_OFF, switchStatus.getRedMode()));
		}
		return false;
	}

	//-------------------
	//	メニュー関連
	//-------------------
	
	@Override
	public boolean onCreateOptionsMenu(Menu menu){
		super.onCreateOptionsMenu(menu);
		MenuInflater inflater = getMenuInflater();
		inflater.inflate(R.menu.calibrate, menu);
		return true;
	}
	@Override
	public boolean onOptionsItemSelected(MenuItem item){
		switch(item.getItemId()){
			case R.id.menuBackToMain:
				closeBluetoothSocket(true);
				Intent intent = new Intent(this, MainActivity.class);
				intent.putExtra(EXTRA_NAME_BT_DEVICE, getBluetoothDevice());
				startActivity(intent);
				return true;
		}
		return false;
	}
	
}