package st.tori.jpredict.levistone.model;

import java.util.Date;

import st.tori.jpredict.core.util.DateUtil;
import android.os.Parcel;
import android.os.Parcelable;

public class Satellite implements Parcelable,Target {

	private int index;
	private Date launchDate;
	private boolean nakedEyeOk;
	private String iconImageUrlInvisible;	
	private String iconImageUrl;
	private String url0;
	private String url1;
	private String name;
	private String code;
	private String organization;
	private String photoUrl;
	private Long catnum;
	
	public Satellite(){}
	public String toString(){
		return "Satellite(name="+name+")";
	}
	
	public Date getLaunchDate() {
		return launchDate;
	}
	public void setLaunchDate(Date launchDate) {
		this.launchDate = launchDate;
	}
	public boolean isNakedEyeOk() {
		return nakedEyeOk;
	}
	public void setNakedEyeOk(boolean nakedEyeOk) {
		this.nakedEyeOk = nakedEyeOk;
	}
	public String getIconImageUrlInvisible() {
		return iconImageUrlInvisible;
	}
	public void setIconImageUrlInvisible(String iconImageUrlInvisible) {
		this.iconImageUrlInvisible = iconImageUrlInvisible;
	}
	public String getIconImageUrl() {
		return iconImageUrl;
	}
	public void setIconImageUrl(String iconImageUrl) {
		this.iconImageUrl = iconImageUrl;
	}
	public String getUrl0() {
		return url0;
	}
	public void setUrl0(String url0) {
		this.url0 = url0;
	}
	public String getUrl1() {
		return url1;
	}
	public void setUrl1(String url1) {
		this.url1 = url1;
	}
	public String getName() {
		return name;
	}
	public void setName(String name) {
		this.name = name;
	}
	public String getCode() {
		return code;
	}
	public void setCode(String code) {
		this.code = code;
	}
	public String getOrganization() {
		return organization;
	}
	public void setOrganization(String organization) {
		this.organization = organization;
	}
	public String getPhotoUrl() {
		return photoUrl;
	}
	public void setPhotoUrl(String photoUrl) {
		this.photoUrl = photoUrl;
	}
	public int getIndex() {
		return index;
	}
	public void setIndex(int index) {
		this.index = index;
	}
	public Long getCatnum() {
		return catnum;
	}
	public void setCatnum(Long catnum) {
		this.catnum = catnum;
	}
	
	//--------------------
	//	Target関連
	//--------------------

	public String getLabelOnTargetList(){	return getName();	}
	public Target[] getSubTargetArray(){	return null;	}
	
	//--------------------
	//	Parcelable関連
	//--------------------

	public int describeContents() {  
		return 0;  
	}
	public static final Parcelable.Creator<Satellite> CREATOR = new Parcelable.Creator<Satellite>() {  
		public Satellite createFromParcel(Parcel in) {  
			return new Satellite(in);  
		}
		public Satellite[] newArray(int size) {  
			return new Satellite[size];  
		}
	};  
	public void writeToParcel(Parcel out, int flags) {  
		out.writeInt(index);
		out.writeString(DateUtil.getDateStr(launchDate));
		out.writeInt((nakedEyeOk)?1:0);
		out.writeString(iconImageUrlInvisible);
		out.writeString(iconImageUrl);
		out.writeString(url0);
		out.writeString(url1);
		out.writeString(name);
		out.writeString(code);
		out.writeString(organization);
		out.writeString(photoUrl);
		out.writeLong(catnum);
	}
	private Satellite(Parcel in) {  
		index = in.readInt();
		launchDate = DateUtil.getStrDate(in.readString());
		nakedEyeOk = (in.readInt()>0);
		iconImageUrlInvisible = in.readString();
		iconImageUrl = in.readString();
		url0 = in.readString();
		url1 = in.readString();
		name = in.readString();
		code = in.readString();
		organization = in.readString();
		photoUrl = in.readString();
		catnum = in.readLong();
	}
}