package st.tori.jpredict.levistone.model.course;


public class SatCoursePointWithAzEl extends SatCoursePoint {

	private double azimuth;
	private double elevation;
	private double slantRangeInKilometer;
	private int sunlightVisibility;
	private double inclination;
	
	public SatCoursePointWithAzEl() {}
	public SatCoursePointWithAzEl(SatCoursePointWithAzEl lastPoint, SatCoursePointWithAzEl nextPoint, long time) {
		setAltitudeInKilometer(getMeanY(lastPoint,lastPoint.getAltitudeInKilometer(),nextPoint,nextPoint.getAltitudeInKilometer(),time));
		setAzimuth(getMeanY(lastPoint,lastPoint.getAzimuth(),nextPoint,nextPoint.getAzimuth(),time));
		setElevation(getMeanY(lastPoint,lastPoint.getElevation(),nextPoint,nextPoint.getElevation(),time));
		setHeading(getMeanY(lastPoint,lastPoint.getHeading(),nextPoint,nextPoint.getHeading(),time));
		setLatitude(getMeanY(lastPoint,lastPoint.getLatitude(),nextPoint,nextPoint.getLatitude(),time));
		setLongitude(getMeanY(lastPoint,lastPoint.getLongitude(),nextPoint,nextPoint.getLongitude(),time));
		setSlantRangeInKilometer(getMeanY(lastPoint,lastPoint.getSlantRangeInKilometer(),nextPoint,nextPoint.getSlantRangeInKilometer(),time));
		setSunlightVisibility((time-lastPoint.getTime().getTime()>nextPoint.getTime().getTime()-time)?nextPoint.getSunlightVisibility():lastPoint.getSunlightVisibility());
		setVelocity(getMeanY(lastPoint,lastPoint.getVelocity(),nextPoint,nextPoint.getVelocity(),time));
		setInclination(nextPoint.getInclination());
	}
	private static double getMeanY(SatCoursePointWithAzEl x0,double y0,SatCoursePointWithAzEl x1,double y1,long x){
		return y0 + ((y1-y0)/(double)(x1.getTime().getTime()-x0.getTime().getTime())) * (double)(x-x0.getTime().getTime());
	}

	public double getAzimuth() {
		return azimuth;
	}
	public void setAzimuth(double azimuth) {
		this.azimuth = azimuth;
	}
	public double getElevation() {
		return elevation;
	}
	public void setElevation(double elevation) {
		this.elevation = elevation;
	}
	public double getSlantRangeInKilometer() {
		return slantRangeInKilometer;
	}
	public void setSlantRangeInKilometer(double slantRangeInKilometer) {
		this.slantRangeInKilometer = slantRangeInKilometer;
	}
	public int getSunlightVisibility() {
		return sunlightVisibility;
	}
	public void setSunlightVisibility(int sunlightVisibility) {
		this.sunlightVisibility = sunlightVisibility;
	}
	public double getInclination() {
		return inclination;
	}
	public void setInclination(double inclination) {
		this.inclination = inclination;
	}
	
}
