package st.tori.jpredict.levistone.network.tsv;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.List;
import java.util.Locale;

import st.tori.jpredict.levistone.AppLocal;
import st.tori.jpredict.levistone.model.Satellite;

public class SatListParser extends AbstractTsvFetcher {
	private static SatListParser instance;
	public static SatListParser getInstance() {
		if (null==instance) instance = new SatListParser();
		return instance;
	}
	public String getSatListUrl() {
		return AppLocal.API_DOMAIN + "/api/sat/list.tsv?complete=true";
	}
	public List getList () throws Exception {
		TsvReader reader = new TsvReader (getSatListUrl());
		reader.read();
		List<Satellite> list = new ArrayList();
		while (reader.hasNext()) {
			TsvLine line = (TsvLine)reader.next();
			Satellite satellite = new Satellite();
			satellite.setIndex(line.getIntAt(0));
			satellite.setCode(line.getStringAt(1));
			satellite.setIconImageUrl(line.getStringAt(2));
			satellite.setIconImageUrlInvisible(line.getStringAt(3));
			satellite.setName(line.getStringAt(4));
			satellite.setNakedEyeOk(line.getBooleanAt(5));
			satellite.setPhotoUrl(line.getStringAt(6));
			satellite.setOrganization(line.getStringAt(9));
			try {
				satellite.setLaunchDate(format.parse(line.getStringAt(12)));
			} catch (Exception ex) {
				ex.printStackTrace();
			}
			satellite.setUrl0(line.getStringAt(13));
			satellite.setUrl1(line.getStringAt(14));
			try {
				satellite.setCatnum(line.getLongAt(20));
			} catch (Exception ex) {
				ex.printStackTrace();
			}
			list.add(satellite);
		}
		return list;
	}

    private static String formatStr = "yyyy-MM-dd";
    private static SimpleDateFormat format = new SimpleDateFormat(formatStr, Locale.US);

}