package st.tori.jpredict.levistone.network.tsv;

import java.util.Date;

import st.tori.jpredict.core.util.DateUtil;

import android.util.Log;

public class TimeParser extends AbstractTsvFetcher {
	
	private static final String TAG = "TimeParser";
	
	private static TimeParser instance;
	public static TimeParser getInstance() {
		if (null==instance) instance = new TimeParser();
		return instance;
	}

	public String getTimeUrl () {
		return "http://torisat.appspot.com/api/time.tsv";
	}
	public long getTimeDiff ()  {
		TsvReader reader = new TsvReader(getTimeUrl());
		Date deviceNow = new Date();
		long timeDiff = 0;
		try {
			reader.read();
			
			while (reader.hasNext()) {
				TsvLine line = (TsvLine) reader.next();
				long realTimeMsec = Long.parseLong(line.getType());// - 30 * 60 * 1000;
				timeDiff = realTimeMsec - deviceNow.getTime();
			}
		} catch (Exception e) {
			e.printStackTrace();
			return 0;
		}
		return timeDiff;
	}

}