package st.tori.jpredict.levistone.network.tsv;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.URI;
import java.net.URISyntaxException;
import java.util.Iterator;

import org.apache.http.HttpResponse;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.DefaultHttpClient;
import org.xmlpull.v1.XmlPullParser;
import org.xmlpull.v1.XmlPullParserFactory;

public class TsvReader implements Iterator {
	private String url;
	private String currentString = null;
    XmlPullParserFactory factory;
    XmlPullParser xpp = null;
    BufferedReader buffer = null;
    
	public TsvReader (String url) {
		this.url = url;
	}
	
	public void read () throws URISyntaxException, Exception, IOException {
		DefaultHttpClient client = new DefaultHttpClient();
		URI uri = new URI(this.url);
		HttpGet method = new HttpGet(uri);
		HttpResponse res = client.execute(method);
		
		InputStream data = res.getEntity().getContent();
		InputStreamReader reader = new InputStreamReader(data);
		buffer = new BufferedReader(reader);

			
	}
	public String getUrl() {
		return url;
	}
	public void setUrl(String url) {
		this.url = url;
	}
	public boolean hasNext() {
		if (buffer==null) return false;
		try {
			do {
				currentString = buffer.readLine();
			} while ("".equals(currentString));
			return (currentString != null);
		} catch (Exception ex) {
			ex.printStackTrace();
		}
		return false;
	}
	public Object next() {
		return new TsvLine(currentString);
	}
	public void remove() {
		//Nothing to do
	}
}