package st.tori.jpredict.levistone.orm;

import st.tori.jpredict.levistone.activity.MainActivity.Offsets;
import st.tori.jpredict.levistone.util.StringUtil;
import android.util.Log;

public class OperandCalibrate extends Operand {

	private static final String TAG = "OperandCalibrate";
	
	public static final int TARGET_A_AZ = 1;
	public static final int TARGET_B_AZ = 2;
	public static final int TARGET_A_EL = 3;
	public static final int TARGET_B_EL = 4;
	private int target;
	private double value;
	
	public OperandCalibrate(int target){
		this.target = target;
	}
	public void write(double value){
		Log.d(TAG,"write:target="+target+",value="+value);
		this.value = value;
		waiting();
	}
	
	@Override
	public String getCmdStr(Offsets offsets) {
		String prefix = null;
		if(target==TARGET_A_AZ)
			prefix = CMD_PREFIX_OPERAND_CALIBRATE_A_AZ;
		else if(target==TARGET_B_AZ)
			prefix = CMD_PREFIX_OPERAND_CALIBRATE_B_AZ;
		else if(target==TARGET_A_EL)
			prefix = CMD_PREFIX_OPERAND_CALIBRATE_A_EL;
		else if(target==TARGET_B_EL)
			prefix = CMD_PREFIX_OPERAND_CALIBRATE_B_EL;
		return (prefix==null)?null:prefix+toString(value);
	}
	private static String toString(double value){
		String str = (value>0.0)?"+":"-";
		double abs = Math.abs(value);
		if(abs>=100)abs = abs%100;
		int intPart = (int)abs;
		str += StringUtil.expandInt(intPart, 2);
		double elsePart = abs - intPart;
		str += StringUtil.expandInt((int)(elsePart*1000), 3);
		Log.d(TAG,"OperandCalibrate.toString("+value+")="+str);
		return str;
	}
	
	public int getTarget() {
		return target;
	}
	public double getValue() {
		return value;
	}


}
