package st.tori.jpredict.levistone.orm;

import android.util.Log;
import st.tori.jpredict.levistone.activity.MainActivity.Offsets;
import st.tori.jpredict.levistone.bizlogic.ReadWriteThread;

public class OperandSwitch extends Operand {

	private static final String TAG = "OperandSwitch";
	
	private int blueMode;
	private int laserMode;
	private int redMode;
	
	private SwitchStatus status;
	public OperandSwitch(SwitchStatus status,int blueMode,int laserMode,int redMode){
		this.status = status;
		this.blueMode = blueMode;
		this.laserMode = laserMode;
		this.redMode = redMode;
	}
	public void switchTo(int blueMode,int laserMode,int redMode){
		Log.d(TAG,"switchTo:blueMode="+this.blueMode+"--->"+blueMode+",laserMode="+this.laserMode+"--->"+laserMode+",redMode="+this.redMode+"--->"+redMode);
		this.blueMode = blueMode;
		this.laserMode = laserMode;
		this.redMode = redMode;
		waiting();
	}
	
	@Override
	public String getCmdStr(Offsets offsets) {
		status.set(status.isAuto(), blueMode, laserMode, redMode);
		return CMD_PREFIX_OPERAND_SWITCH+Integer.toString(blueMode)+Integer.toString(laserMode)+Integer.toString(redMode)+ReadWriteThread.CMD_SUFFIX;
	}

	public int getBlueMode() {
		return blueMode;
	}

	public void setBlueMode(int blueMode) {
		this.blueMode = blueMode;
	}

	public int getLaserMode() {
		return laserMode;
	}

	public void setLaserMode(int laserMode) {
		this.laserMode = laserMode;
	}
	public int getRedMode() {
		return redMode;
	}
	public void setRedMode(int redMode) {
		this.redMode = redMode;
	}

}
