package st.tori.jpredict.levistone.orm;

import java.util.ArrayList;
import java.util.List;

public class RotateStatus {

	//OperandRotateとは異なり、ここには必ずVartualな値が入る
	
	private double azimuth;
	private double elevation;
	
	private List<RotateStatusLog> logList = new ArrayList<RotateStatusLog>();
	private double inclination;
	public boolean isOkAzimuth360To0(){
		return (inclination<=90||inclination>=270);
	}
	
	public RotateStatus(double azimuth,double elevation) {
		set(azimuth,elevation);
	}
	public void set(double azimuth,double elevation) {
		this.azimuth = azimuth;
		this.elevation = elevation;
	}
	public String toString() {
		return "RotateStatus:azimuth="+azimuth+",elevation="+elevation;
	}
	
	public double getAzimuth() {
		return azimuth;
	}
	public void setAzEl(double azimuth,double elevation) /*throws RotateException*/ {
		//checkLogList(azimuth);
		this.azimuth = azimuth;
		this.elevation = elevation;
		this.logList.add(new RotateStatusLog(azimuth,elevation,System.currentTimeMillis()));
		cleanLogList();
	}
	public static class RotateException extends Exception {
		private double wrongAzimuth;
		private double correctAzimuth;
		public RotateException(double wrongAzimuth,double correctAzimuth){
			this.wrongAzimuth = wrongAzimuth;
			this.correctAzimuth = correctAzimuth;
		}
		public double getWrongAzimuth(){	return wrongAzimuth;	}
		public double getCorrectAzimuth(){	return correctAzimuth;	}
	}
	private static final int LOG_LIST_CHECK_SPAN_IN_MIN = 2;
	private void checkLogList(double azimuth) throws RotateException {
		long limit = System.currentTimeMillis() - LOG_LIST_CHECK_SPAN_IN_MIN*60*1000;
		//TODO if needed
	}
	private static final int LOG_LIST_SAVE_SPAN_IN_MIN = 5;
	private void cleanLogList(){
		if(logList.size()<=0)return;
		long limit = System.currentTimeMillis() - LOG_LIST_SAVE_SPAN_IN_MIN*60*1000;
		if(limit<logList.get(0).getDeviceSystemTimeInMillis())return;
		for(int i=0;i<logList.size();i++){
			if(limit>logList.get(i).getDeviceSystemTimeInMillis())continue;
			logList = logList.subList(i, logList.size());
			return;
		}
		return;
	}
	public double getElevation() {
		return elevation;
	}
	public double getInclination() {
		return inclination;
	}
	public void setInclination(double inclination) {
		this.inclination = inclination;
	}
	
	
}
